#include <bits/stdc++.h>

using namespace std;

int main()
{
    long long n, q, k, u=0, o=0, b=0, l=0;
    cin>>n>>q;
    vector<long long> d(n+1);
    vector<int> p(n);
    d[n]=LONG_LONG_MAX;
    for(int i=0;i<n;i++)
    {
        cin>>d[i];
        cin>>p[i];
        d[i]--;
    }
    for(int i=0;i<q;i++)
    {
        cin>>k;
        for(long long j=l;j<k;j++)
        {
            if(b<n && d[b]==j)
            {
                u+=p[b];
                b++;
            }
            if(u!=0)
            {
                o+=min(u,min(d[b],k)-j);
                u-=min(u,min(d[b],k)-j);
                j=min(d[b],k)-1;
            }
            else j=d[b]-1;
        }
        cout<<o<<endl;
        l=k;
    }
    return 0;
}